﻿/*
	This file is part of Warzone Stat Editor by crab
    Copyright © 2011, 2012 Vladimir Salnikov

	Warzone Stat Editor by crab is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Warzone Stat Editor by crab is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Warzone Stat Editor by crab; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using Microsoft.CSharp;
using System.CodeDom.Compiler;
using System.Reflection;

namespace WZStats
{
    public partial class CompilerForm : DevExpress.XtraEditors.XtraForm
    {
        public CompilerForm()
        {
            InitializeComponent();
        }

        private void simpleButton1_Click(object sender, EventArgs e)
        {
            CSharpCodeProvider csp = new CSharpCodeProvider();
            CompilerParameters cp = new CompilerParameters();
            cp.ReferencedAssemblies.Add("System.dll");
            cp.ReferencedAssemblies.Add("System.Data.dll");
            cp.ReferencedAssemblies.Add("mscorlib.dll");
            cp.ReferencedAssemblies.Add("System.Windows.Forms.dll");
            cp.GenerateInMemory = true;

            string code = @"using System;
                            using System.Windows.Forms;

                            namespace WZStats
                            {
                                public static class DynamicCode
                                {
                                    public static void DynamicMethod()
                                    {
                                        " + memoEdit1.Text+
                                    @" }
                                }
                            }";
            CompilerResults results = csp.CompileAssemblyFromSource(cp, code);
            if (!results.Errors.HasErrors)
            {
                var cls = results.CompiledAssembly.GetType("WZStats.DynamicCode");
                var method = cls.GetMethod("DynamicMethod", BindingFlags.Static | BindingFlags.Public);
                method.Invoke(null, null);
            }
            memoEdit2.Text = "";
            foreach(string s in results.Output)
            {
                memoEdit2.Text += s + "\r\n";
            }
           
                
            
        }
    }
}