﻿/*
	This file is part of Warzone Stat Editor by crab
    Copyright © 2011, 2012 Vladimir Salnikov
 
	Warzone Stat Editor by crab is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Warzone Stat Editor by crab is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Warzone Stat Editor by crab; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Grid.ViewInfo;

namespace WZStats
{
    public partial class EditorForm : DevExpress.XtraEditors.XtraForm
    {
        public GridSelectCheckBox SelectionClass = null;
        public Stats stats;
        public bool read_only = false;
        public EditorForm(Stats stats, bool read_only = false)
        {
            InitializeComponent();
            this.stats = stats;
            this.read_only = read_only;
        }

        private void repositoryItemSpinEdit1_ValueChanged(object sender, EventArgs e)
        {
            
        }

        private void repositoryItemTrackBar1_ValueChanged(object sender, EventArgs e)
        {

        }

        private void repositoryItemSpinEdit1_EditValueChanged(object sender, EventArgs e)
        {

        }

        private void vGridControl1_CellValueChanged(object sender, DevExpress.XtraVerticalGrid.Events.CellValueChangedEventArgs e)
        {
            
        }

        private void repositoryItemSpinEdit1_Spin(object sender, DevExpress.XtraEditors.Controls.SpinEventArgs e)
        {

        }

        private void repositoryItemSpinEdit1_Validating(object sender, CancelEventArgs e)
        {
            
        }

        private void repositoryItemSpinEdit1_Modified(object sender, EventArgs e)
        {

        }

        public void MakeSpaceForLinkTables(int Height)
        {
            if (Height > this.Height - 50) return;
            int i = 0;
            while (Math.Abs(splitContainerControl2.SplitterPosition - 
                                                splitContainerControl3.SplitterPosition) < Height)
            {
                splitContainerControl3.SplitterPosition -= 20;
                splitContainerControl2.SplitterPosition += 20;
                i++;
                if (i > 100) break;
            }

        }

        private void repositoryItemButtonEdit2_ButtonClick(object sender, DevExpress.XtraEditors.Controls.ButtonPressedEventArgs e)
        {

        }

        private void dataNavigator1_ButtonClick(object sender, NavigatorButtonClickEventArgs e)
        {
            if (e.Button.ButtonType == NavigatorButtonType.Remove)
                if (MessageBox.Show("Warning! Deleting rows strongly not recommended and program process will delete operations with some errors. "
                    +"\r\nConfirm delete selected row?", "Confirmation", MessageBoxButtons.YesNo) ==
                    System.Windows.Forms.DialogResult.No)
                    e.Handled = true;
        }

        private void dataNavigator1_Click(object sender, EventArgs e)
        {

        }

        private void vGridControl1_CellValueChanged_1(object sender, DevExpress.XtraVerticalGrid.Events.CellValueChangedEventArgs e)
        {

        }

        private void vGridControl1_CellValueChanging(object sender, DevExpress.XtraVerticalGrid.Events.CellValueChangedEventArgs e)
        {

        }

        private void vGridControl1_RowChanging(object sender, DevExpress.XtraVerticalGrid.Events.RowChangingEventArgs e)
        {
            
        }

        private void vGridControl1_ValidateRecord(object sender, DevExpress.XtraVerticalGrid.Events.ValidateRecordEventArgs e)
        {
            
        }

        private void vGridControl1_ValidatingEditor(object sender, DevExpress.XtraEditors.Controls.BaseContainerValidateEditorEventArgs e)
        {
            
        }

        private void xtraTabControl1_SelectedPageChanged(object sender, DevExpress.XtraTab.TabPageChangedEventArgs e)
        {

        }

        private void tabControl_SelectedPageChanging(object sender, DevExpress.XtraTab.TabPageChangingEventArgs e)
        {
            if (e.Page.Name == "tabComparison")
            {
                if (SelectionClass != null)
                {
                    if (SelectionClass.SelectedCount == 0)
                    {
                        vGridComparison.DataSource = null;
                        tabControl.TabIndex = 0;
                        MessageBox.Show("To compare parameters you have to select some rows in list.");
                        e.Cancel = true;
                        return;
                    }
                    DataTable dt = gridControl1.DataSource as DataTable;
                    if (!dt.Columns.Contains("ComparisonSortIndex"))
                        dt.Columns.Add("ComparisonSortIndex", typeof(Int32));

                    if (dt == null) return;
                    DataView dw = new DataView(dt);
                    string filter_codes = "";
                    for (int i = 0; i < SelectionClass.SelectedCount; i++)
                    {
                        DataRowView RowView = SelectionClass.GetSelectedRow(i) as DataRowView;
                        if (RowView == null) continue;
                        filter_codes += "'" + RowView.Row[0].ToString() + "',";
                        RowView.Row["ComparisonSortIndex"] = i;
                    }
                    if (filter_codes != "")
                    {
                        filter_codes = filter_codes.Remove(filter_codes.Length - 1, 1);
                        dw.RowFilter = dt.Columns[0].ColumnName + " IN (" + filter_codes + ")";
                        dw.Sort = "ComparisonSortIndex";
                        vGridComparison.DataSource = dw;
                    }
                    else
                    {
                        vGridComparison.DataSource = null;
                    }
                }

            }
            else if (e.Page.Name == "tabResearch")
            {
                DataTable dt_items = gridControl1.DataSource as DataTable;
                ClassResearch clres = new ClassResearch(stats);
                if(!dt_items.Columns.Contains("Code"))
                    return;
                int pos = dataNavigator1.Position;
                if(pos <0 || pos >= dt_items.Rows.Count)
                    return;
                DataTable restree = clres.MakeResTreeForItem((string)dt_items.Rows[pos]["Code"]);
                if(restree == null)
                {
                    MessageBox.Show("Research was not loaded in current wz-file");
                    e.Cancel = true;
                    return;
                }
                treeList1.DataSource = restree;
                treeList1.ParentFieldName = "ParentID";
                treeList1.KeyFieldName = "ID";
                treeList1.PopulateColumns();
                if (treeList1.Columns["Name"] != null)
                {
                    treeList1.Columns["Name"].VisibleIndex = 0;
                    treeList1.Columns["Name"].Width = 300;
                    treeList1.Columns["Code"].VisibleIndex = 2;
                }
                else
                {
                    treeList1.Columns["Code"].VisibleIndex = 0;
                    treeList1.Columns["Code"].Width = 300;
                }
                treeList1.Columns["Research points"].VisibleIndex = 1;
                treeList1.Columns["Research points"].Width = 100;
                treeList1.ExpandAll();
            }
        }

        private void btCopy_Click(object sender, EventArgs e)
        {
            DataTable dt = gridControl1.DataSource as DataTable;
            if(dt == null) return;
            
            int pos = dataNavigator1.Position;
            DataRow old_row;
            DataRow new_row;
            if(pos >=0 && pos < dt.Rows.Count)
            {
                old_row = dt.Rows[pos];
                new_row = dt.NewRow();
                foreach(DataColumn col in dt.Columns)
                {
                    if(col.Unique)
                    {
                        string cur_name = old_row["Code"] + "_copy";
                        int cur_index = 1;
                        string res_name = cur_name + cur_index.ToString();
                        //find copy number
                        while (cur_index<100)
                        {
                            DataRow[] f1 = dt.Select("["+col.ColumnName + "]='" + res_name +"'");
                            if (f1.Length == 0)
                                break;
                            cur_index++;
                            res_name = cur_name + cur_index.ToString();
                        }
                        new_row["Code"] = res_name;
                    }else
                        new_row[col] = old_row[col];
                }
                dt.Rows.Add(new_row);
                dataNavigator1.Position = dt.Rows.IndexOf(new_row);
            }
        }

        private void tabControl_DoubleClick(object sender, EventArgs e)
        {
            
        }

        private void treeList1_MouseDoubleClick(object sender, MouseEventArgs e)
        {

        }

        private void leSelectFromFile_ButtonClick(object sender, DevExpress.XtraEditors.Controls.ButtonPressedEventArgs e)
        {

        }

        private void dataNavigator1_PositionChanged(object sender, EventArgs e)
        {

        }

        private void gridView1_FocusedRowChanged(object sender, DevExpress.XtraGrid.Views.Base.FocusedRowChangedEventArgs e)
        {

        }

        private void EditorForm_Load(object sender, EventArgs e)
        {
            if (read_only)
            {
                btCopy.Enabled = false;
                dataNavigator1.Enabled = false;
                gridView1.OptionsBehavior.Editable = false;
                //vGridComparison.OptionsBehavior.Editable = false;
                //vGridControl1.OptionsBehavior.Editable = false;
            }
        }

    }
}