﻿/*
	This file is part of Warzone Stat Editor by crab
    Copyright © 2011, 2012 Vladimir Salnikov
 
	Warzone Stat Editor by crab is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Warzone Stat Editor by crab is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Warzone Stat Editor by crab; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DevExpress.XtraEditors;
using DevExpress.XtraSplashScreen;
using System.Threading;

namespace WZStats
{
    public partial class StatComparer : DevExpress.XtraEditors.XtraForm, VirtualForm
    {
        Stats OriginalWzStats = null;
        public StatComparer(Stats OriginalWzStats=null)
        {
            InitializeComponent();
            this.OriginalWzStats = OriginalWzStats;
        }


        private void labelControl2_Click(object sender, EventArgs e)
        {

        }

        private void buttonEdit1_ButtonClick(object sender, DevExpress.XtraEditors.Controls.ButtonPressedEventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                buttonEdit1.Text = openFileDialog1.FileName;
            }
        }

        private void buttonEdit2_ButtonClick(object sender, DevExpress.XtraEditors.Controls.ButtonPressedEventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                buttonEdit2.Text = openFileDialog1.FileName;
            }
        }



        private void simpleButton1_Click(object sender, EventArgs e)
        {
#if ! DEBUG            
            try
            {
#endif
                ShowLoadingPanel();
                StatMetadata statfields = new StatMetadata();
                statfields.Load("stats_metadata.csv");
                Stats oldstats = new Stats("filelist.csv", "stats_metadata.csv", this);
                oldstats.Load(buttonEdit1.Text);
                Stats newstats = new Stats("filelist.csv", "stats_metadata.csv", this);
                newstats.Load(buttonEdit2.Text);
                double chpercent = Convert.ToDouble(edPercent.Value);
                string result = "";
                oldstats.CodeFunctions_PerformForcedCalculations();
                newstats.CodeFunctions_PerformForcedCalculations();
                foreach (string sfile in newstats.FileList.Keys)
                {
                    // bool CodeExists
                    result += "\r\n *** " + sfile + " ***";
                    if (!oldstats.FileList.ContainsKey(sfile))
                    {
                        result += "\r\n FILE " + sfile + " NOT FOUND IN OLD STATS";
                        continue;
                    }
                    if (newstats.FileList[sfile].IsNames)
                        continue;
                    if (!oldstats.FileList[sfile].Loaded)
                    {
                        result += "\r\n FILE " + sfile + " NOT FOUND IN OLD STATS";
                        continue;
                    }
                    if (!newstats.FileList[sfile].Loaded)
                    {
                        result += "\r\n FILE " + sfile + " NOT FOUND IN NEW STATS";
                        continue;
                    }
                    //if (newstats.FileList[sfile].NamesFile != "")
                    //{
                    //    oldstats.UpdateNameColumn(sfile);
                    //    newstats.UpdateNameColumn(sfile);
                    //}
                    //if(newstats.FileList[sfile].Loaded)
                    //if (!newstats.FileList[sfile].data.Columns.Contains("Code"))
                    //    continue;

                    //add name columns for make code work
                    //if (!newstats.FileList[sfile].data.Columns.Contains("Name"))
                    //    newstats.FileList[sfile].data.Columns.Add("Name", typeof(String));
                    //if (!oldstats.FileList[sfile].data.Columns.Contains("Name"))
                    //    oldstats.FileList[sfile].data.Columns.Add("Name", typeof(String));

                    bool name_new_ok = newstats.FileList[sfile].data.Columns.Contains("Name");
                    bool name_old_ok = oldstats.FileList[sfile].data.Columns.Contains("Name");
                    bool code_new_ok = newstats.FileList[sfile].data.Columns.Contains("Code");
                    bool code_old_ok = oldstats.FileList[sfile].data.Columns.Contains("Code");
                    DataRow[] fields = statfields.data.Select("filename = '" + sfile + "'");

                    foreach (DataRow nrow in newstats.FileList[sfile].data.Rows)
                    {
                        string row_name = "";
                        if (name_new_ok && code_new_ok)
                        {
                            row_name = (string)nrow["Name"];
                        }

                        string sel_row = "";
                        string showed_item_key = "";
                        foreach (int keyind in newstats.FileList[sfile].KeyColumns)
                        {
                            sel_row += "[" + oldstats.FileList[sfile].data.Columns[keyind].ColumnName +
                                        "]='" + nrow[keyind] + "',";
                            showed_item_key += nrow[keyind] + " ";
                        }
                        showed_item_key = "[" + showed_item_key.Remove(showed_item_key.Length - 1, 1) + "]";
                        sel_row = sel_row.Remove(sel_row.Length - 1, 1).Replace(",", " AND ");


                        DataRow[] orows =
                            oldstats.FileList[sfile].data.Select(sel_row);
                        if (orows.Length == 0)
                        {
                            result += "\r\n New item: " + row_name + " " + showed_item_key;
                            foreach (DataRow field in fields)
                            {
                                string fname = field["Caption"].ToString();
                                result += "\r\n\t-Field Name: '" + fname + "\tnew value: " +
                                            nrow[fname].ToString();
                            }
                        }
                        else
                        {
                            if (row_name == "" && name_old_ok && code_old_ok)
                            {
                                row_name = (string)orows[0]["Name"];
                            }
                            else if (OriginalWzStats != null && (code_old_ok || code_new_ok))
                            {
                                string code = "";
                                if (code_new_ok)
                                    code = (string)nrow["Code"];
                                else if (code_old_ok)
                                    code = (string)orows[0]["Code"];
                                if (code != "" && OriginalWzStats.FileList[sfile].Loaded && !OriginalWzStats.FileList[sfile].IsNames)
                                {
                                    DataTable dt_org = OriginalWzStats.FileList[sfile].data;
                                    if (dt_org.Columns.Contains("Code") && dt_org.Columns.Contains("Name"))
                                    {
                                        DataRow[] org_rows = dt_org.Select("Code = '" + code + "'");
                                        if (org_rows.Length > 0)
                                            row_name = (string)org_rows[0]["Name"];
                                    }
                                }
                            }
                            if (orows.Length > 1)
                                result += "\r\n Error?? count > 1 for item:  " + row_name + " " + showed_item_key;
                            bool StartedWriteChanges = false;
                            foreach (DataRow field in fields)
                            {
                                string fname = field["Caption"].ToString();
                                if (nrow[fname].ToString().Trim() != orows[0][fname].ToString().Trim())
                                {
                                    int vo, vn;

                                    if (chpercent > 0)
                                        if (Int32.TryParse(orows[0][fname].ToString(), out vo))
                                            if (Int32.TryParse(nrow[fname].ToString(), out vn))
                                            {
                                                if (vo != 0)
                                                    if (Math.Abs(vn - vo) * 100 / vo < chpercent)
                                                        continue;
                                            }
                                    if (!StartedWriteChanges)
                                    {
                                        result += "\r\n Changed item: " + row_name + " " + showed_item_key;
                                        StartedWriteChanges = true;
                                    }
                                    result += "\r\n\t-Field Name: '" + fname + "'\told value:"
                                                + orows[0][fname].ToString() + "\tnew value: " +
                                                nrow[fname].ToString();
                                }
                            }
                        }
                    }
                    //Find what was deleted in new stats
                    if (!oldstats.FileList[sfile].Loaded)
                        continue;
                    foreach (DataRow orow in oldstats.FileList[sfile].data.Rows)
                    {
                        string row_name = "";
                        if (name_old_ok && code_old_ok)
                        {
                            row_name = (string)orow["Name"];
                        }

                        string sel_row = "";
                        string showed_item_key = "";
                        foreach (int keyind in newstats.FileList[sfile].KeyColumns)
                        {
                            sel_row += "[" + oldstats.FileList[sfile].data.Columns[keyind].ColumnName +
                                        "]='" + orow[keyind] + "',";
                            showed_item_key += orow[keyind] + " ";
                        }
                        showed_item_key = "[" + showed_item_key.Remove(showed_item_key.Length - 1, 1) + "]";
                        sel_row = sel_row.Remove(sel_row.Length - 1, 1).Replace(",", " AND ");

                        DataRow[] nrows = newstats.FileList[sfile].data.Select(sel_row);
                        if (nrows.Length == 0)
                        {
                            result += "\r\n DELETED item: " + row_name + " " + showed_item_key;
                        }
                    }
                }

                memoEdit1.Text = result;
#if ! DEBUG   
            }
            catch (Exception err)
            {
                MessageBox.Show("Operation was not completed due to error");
                memoEdit1.Text = err.Message;
            }
            finally
            {
#endif
                HideLoadingPanel();
#if ! DEBUG    
            }
#endif

        }
        public bool loading_panel_opened = false;
        public void ShowLoadingPanel(string message = "")
        {
            if (!loading_panel_opened)
            {
                SplashScreenManager.ShowForm(typeof(WaitForm1));
                loading_panel_opened = true;
            }
        }

        public void HideLoadingPanel(string message = "")
        {
            if (loading_panel_opened)
            {
                SplashScreenManager.CloseForm();
                loading_panel_opened = false;
            }
        }
    }
}